/* program to pull addr & data & such from a report file : RWS : 87FEB92 : */

#include <stdio.h>

#define LINESIZE 250

char	line[LINESIZE+2];
char	rest[LINESIZE+2];

int badaddr, baddata;

int btoi(s)	/* Convert a space terminated binary string to integer */
char *s;
{
	int i;
	long sumtotal;
	
	i=0;
	sumtotal = 0;    

	for(i=0; s[i] != ' '; i++) {
		if ((s[i] == '1') || (s[i] == 'H')) sumtotal++;
		if ((s[i] == '.') || (s[i] == '/') || (s[i] == '*')) baddata = 1;
		sumtotal = sumtotal * 2;
	}  	
	return((int)(sumtotal/2));
}  

long addrtol(s)	/* Convert a space terminated binary string to integer */
char *s;
{
	int i;
	long sumtotal;
	
	i=0;
	sumtotal = 0;    
   
	for(i=0; s[i] != ' '; i++) {
		if ((s[i] == '1') || (s[i] == 'H')) sumtotal++;
		if ((s[i] == '.') || (s[i] == '/') || (s[i] == '*')) badaddr = 1;
               sumtotal = sumtotal * 2;
	}  	
	
	return(sumtotal);
}  

long GetAddr()
{
	int i;
	long addr;
	char	ad[24];

	for (i=0; i<23; i++) {
		ad[i] = line[23-i];
		line[23-i] = ' ';
	}
	ad[23] = ' ';
	addr = addrtol(ad);
	return addr;
}

int GetCData()
{
	int i, cdata;
	char	cd[9];

	for (i=0; i<8; i++) {
		cd[i] = line[42-i];
		line[42-i] = ' ';
	}
	cd[8] = ' ';
	cdata = btoi(cd);
	return cdata;
}
int GetData()
{
	int i, data;
	char	d[17];

	for (i=0; i<16; i++) {
		d[i] = line[64-i];
		line[64-i] = ' ';
	}
	d[16] = ' ';
	data = btoi(d);
	return data;
}

makerest()
{
	int i, j=0, spc1 = 0;

	for (i=0; i<LINESIZE+1; i++) {
		if (line[i] != ' ') {
			rest[j++] = line[i];
			spc1 = 0;
		} else 
		if (!spc1) { rest[j++] = ' '; spc1 = 1; }
		if (i%4 == 0) rest[j++] = ' ';
	}
	rest[j] = '\0';
}


main()
{
	char mod, origline[LINESIZE+1];
	long addr= 0x37;
	int cdata=0xfe, data=0xff;

	while(fgets(line,LINESIZE,stdin) > 0) {
		badaddr = 0; 
		baddata = 0;
		strcpy(origline,line);
		mod = line[0];
		line[0] = ' ';
		addr = GetAddr();
		cdata = GetCData();
		data = GetData();

		makerest();			/* shrink leftover line */

		if ((badaddr + baddata) != 0) 
			printf("%c %7lx %5x %3x %s",mod,addr,data,cdata,rest);
		if (badaddr==1 && baddata==0) {
			printf("%c  ?????? %5x %3x %s",mod,data,cdata,rest);
			if (mod == '>') printf("%s",origline);
		}
		if (badaddr==0 && baddata==1) {
			printf("%c, %7lx  ????  ???? %s",mod,addr,rest);
			if (mod == '>') printf("%s",origline);
		}
		if (badaddr==1 && baddata==1)  {
			printf("%c  ??????  ????  ???? %s",mod,rest);
			if (mod == '>') printf("%s",origline);
		}
		
	}
}
