/*
 InSpace.c - insert spaces at specified locations in input file

 By Roy Stedman @ Atari 07FEB92
*/

#include <stdio.h>

#define LINESIZE 250

char	line[LINESIZE+2];	/* DO NOT OVERFLOW THESE!!! */
char	rest[LINESIZE*2];

/* ORDERED list of char spots to insert spaces at in ORIGINAL! */ 
int	insertafter[] = {23,26,31,34,42,48,64,67,70,75};	/* setup for SDMA rev B parts */

main()
{
	int i,j,k;

	while(fgets(line,LINESIZE,stdin) > 0) {
		j = 0;
		k = 0;
		for(i=0; i<LINESIZE; i++) {
			rest[j++] = line[i];	
			if ( i == insertafter[k] ) {
				rest[j++] = ' ';
				k++;
			}
		}
		printf("%s",rest);
	}
}
