	char * btoa();
	char * addrtola();
	char hex[] = { '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F' };
	char	outpt[7];
bit [HL01*/.]
bit3 [HL01*/.]{3}
byte [HL01*/.]{8}
word [HL01*/.]{16}
addr [HL01*/.]{23}
int [0-9]+
S [ \t]+
S1 [ \t]
NL [\n]
headj {NL}{S1}[> ]{bit}{S1}{bit}{bit}{bit}{bit}{S1}{bit}{S1}
%%
{addr}" " { printf("%s ",addrtola(yytext)); }
{word}" " { printf("%s ",btoa(yytext)); }
{byte}" " { printf("%s ",btoa(yytext)); } 
%%
int btoi(s)	/* Convert a space terminated binary string to integer */
char *s;
{
	int i, err;
	long sumtotal;
	
	i=0; err = 0;
	sumtotal = 0;    

	for(i=0; s[i]!=' '; i++) {
		if ((s[i] == '1') || (s[i] == 'H')) sumtotal++;
		sumtotal = sumtotal * 2;
		if ((s[i] != '0') && (s[i] != 'L') && (s[i] != '1') && (s[i] != 'H')) err = 1;
	}  	
	if (err == 0) return((int)(sumtotal/2));
	else return(-1);
}  
char itofc(a)	/* convert a small integer to one hex digit */
int a;
{
	if (a < 0) return ('X');
	else return( hex[ ( a & 0xF ) ] );
}	

char *btoa(s)	/* binary string to hex string */
char *s;
{
	int i, len, out;
	char	f[4][5];

	len = strlen(s);
	for(i=0; i<len; i++)
		f[i/4][i%4] = s[i];
	for (i=0; i<4; i++)
		f[i][4] = ' ';

	for (i=0; i<4; i++) {
		out = btoi(f[i]);
		outpt[i] = itofc(out);
 	}
	if (len > 9) outpt[4] = '\0';
	else outpt[2] = '\0';
	return(outpt);		    
}  

char *addrtola(s)	/* Convert a space terminated binary string to hex */
char *s;
{
	int i,j, len, out;
	char	f[6][5];

	len = strlen(s);
	for (j=0; j<6; j++) {
		for(i=0; i<4; i++ ) {
			f[j][i] = s[i+(j*4)];
		}
	}
	f[5][3] = '0';			/* extra address bit */
	for (i=0; i<6; i++)
		f[i][4] = ' ';
	for (i=0; i<6; i++) {
		out = btoi(f[i]);
		outpt[i] = itofc(out);
 	}
	outpt[7] = '\0';
	return(outpt);		    
}  

main()
{
	printf("nihex.lex \n By Roy Stedman\n - Converts blitter vector addr & data to hex\n");
	yylex();
}
